/*
 * input binary file and output simh compatible binary paper tape
 * load file
 */

#include <stdio.h>

int bcount;
unsigned char buffer[256];

int origin, start_pc;

void
flush(void)
{
	unsigned char hdr[6], sumbyte;
	int i, count, csum;

	count = 6 + bcount;

	hdr[0] = 1;
	hdr[1] = 0;
	hdr[2] = count & 0xff;
	hdr[3] = count >> 8;
	hdr[4] = origin & 0xff;
	hdr[5] = origin >> 8;

	write(1, hdr, 6);

	if (bcount > 0)
		write(1, buffer, bcount);

	csum = 0;
	for (i = 0; i < 6; i++)
		csum += hdr[i];
	for (i = 0; i < bcount; i++)
		csum += buffer[i];

	sumbyte = ~(csum & 0xff) + 1;
	hdr[0] = sumbyte;
	write(1, hdr, 1);

	if (0) fprintf(stderr, "bcount %d, count %d, csum 0x%x sumbyte %x result %x\n",
		       bcount, count, csum, sumbyte, sumbyte + csum);

	origin += bcount;
	bcount = 0;
}

void
push_byte(int b)
{
	if (b == -1) {
		flush();
		return;
	}

	buffer[bcount++] = b;
	if (bcount == 256)
		flush();
}

main()
{
	int c;

	origin = 0;
	start_pc = 0;

	while ((c = getc(stdin)) != EOF) {
		push_byte(c);
	}

	push_byte(-1);

	origin = start_pc;
	push_byte(-1);

	exit(0);
}
